package com.kingdee.eas.custom.shuiyou.six.handler;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.incomeTax.TaxDirectDeductionExFacadeFactory;

import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;
import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.uitls.URLConfigEnum;
import com.kingdee.eas.custom.shuiyou.vo.SixTConfirmInfo;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.filter.HRFilterUtils;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;

import com.kingdee.shr.compensation.app.tax.TaxUnitCollection;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.app.taxCal.*;

import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.util.CmpDateUtil;
import com.kingdee.shr.compensation.util.CmpStrUtil;

import com.kingdee.shr.compensation.util.TaxReportUtil;
import com.kingdee.shr.compensation.util.filter.CmpTaxUnitPermFilter;
import com.kingdee.shr.compensation.util.lock.CmpDistributedLockUtils;
import com.kingdee.shr.compensation.web.handler.tax.TaxDirectDeductionListHandler;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Timestamp;
import java.util.*;

/**
 * 6ȷ
 * description: TaxDirectDeductionListHandlerEx <br>
 * date: 2024/8/28 14:42 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class TaxDirectDeductionListHandlerEx extends TaxDirectDeductionListHandler {
    private static final Logger LOG = Logger.getLogger(TaxDirectDeductionListHandler.class);

    protected FilterInfo getDefaultFilter(HttpServletRequest request, HttpServletResponse response) throws SHRWebException {
        FilterInfo customFilter = null;
//        Context ctx = SHRContext.getInstance().getContext();
//        String sql = CmpTaxUnitPermFilter.getCurPersonPermTaxUnitSql(ctx);
//        String inRange = "''";
//        if (!"".equals(sql)) {
//            inRange = sql;
//        }
//
//        String oql = "taxPersonRecordEntry.taxUnit.id in (" + inRange + ")";
//        if (customFilter == null) {
//            //int lastYear = CmpDateUtil.getYear(new Date()) - 1;
//           // oql = oql + " and taxUnitDeduction.year = " + lastYear;
//
//            try {
//                customFilter = new FilterInfo(oql);
//            } catch (ParserException var12) {
//                LOG.error(var12.getMessage(), var12);
//            }
//        } else {
//            try {
//                FilterInfo inRangeFilterInfo = new FilterInfo(oql);
//                customFilter.mergeFilter(inRangeFilterInfo, "AND");
//            } catch (BOSException var10) {
//                LOG.error(var10.getMessage(), var10);
//            } catch (ParserException var11) {
//                LOG.error(var11.getMessage(), var11);
//            }
//        }

        return customFilter;
    }


    /**
     * ȡԱ
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void personCollectAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        String ids = request.getParameter("taxUnitIds");
        String period = request.getParameter("period");
        int thisYear = CmpDateUtil.getYear(new Date());
        Map<String, Object> map = new HashMap();
        map.put("taxUnitIds", ids);
        if(!StringUtils.isEmpty(period)&&period.indexOf("-")>=0){
            String[] periods=period.split("-");
            map.put("period", periods[0]+"-01");
        } else {
            map.put("period", (thisYear-1) + "-01");
        }
        try {
            List<IObjectPK> list = this._staffCollection(ctx,map);
        } catch (BOSException var9) {
            LOG.error("staffCollection failed, caused by: ", var9);
            throw new ShrWebBizException(var9.getMessage());
        }
    }


    protected List _staffCollection(Context ctx, Map paramMap) throws BOSException {

        if (null != paramMap && null != paramMap.get("taxUnitIds") && null != paramMap.get("period")) {
            String taxUnitIds = (String)paramMap.get("taxUnitIds");
            List<IObjectPK> arrayList = new ArrayList();
            String oql = "select id,name,number,taxNumber,areaCode,regNumber,declPassword,realPassword,isAutoDeduct where id in " + CmpStrUtil.buildInSql(taxUnitIds);
            TaxUnitCollection taxUnitCollection = TaxUnitFactory.getLocalInstance(ctx).getTaxUnitCollection(oql);
            List<Object[]> params = new ArrayList();
            ISYUtilsFacade facade = SYUtilsFacadeFactory.getLocalInstance(ctx);
            Map<String,String> config =facade.getConfig();
            for(int i = 0; i < taxUnitCollection.size(); ++i) {
                TaxUnitInfo taxUnitInfo = taxUnitCollection.get(i);
                String yearMonth = TaxReportUtil.getCurrentYearMonth((String)paramMap.get("period"));
                int year = Integer.parseInt(yearMonth.substring(0, 4));
                SixTConfirmInfo sixTConfirmInfo = new SixTConfirmInfo();
                sixTConfirmInfo.setBizNo(System.currentTimeMillis()+"");
                sixTConfirmInfo.setQymc(taxUnitInfo.getName());
                sixTConfirmInfo.setMmlx(null);
                sixTConfirmInfo.setSmzh(null);
                sixTConfirmInfo.setSmmm(null);
                sixTConfirmInfo.setJmsmmm(null);
                sixTConfirmInfo.setDjxhid(taxUnitInfo.getRegNumber());
                sixTConfirmInfo.setNsrsbh(taxUnitInfo.getTaxNumber());
                sixTConfirmInfo.setAreaid(taxUnitInfo.getAreaCode());
                sixTConfirmInfo.setBmbh(null);
                sixTConfirmInfo.setBmmc(null);
                sixTConfirmInfo.setSbmm(Base64Utils.decode(taxUnitInfo.getDeclPassword()));
                sixTConfirmInfo.setJmsbmm(null);
                sixTConfirmInfo.setSkssnd(String.valueOf(year));
                taxUnitInfo.put("year",year);
                //sixTConfirmInfo.setAcceptId(acceptIdMap.get(taxUnitDeductionInfo.getId().toString()));
                sixTConfirmInfo.setTAXUNITID(taxUnitInfo.getId().toString());
                String result = facade.post(config.get("ip")+ URLConfigEnum.QUERYPREDEDUCT_VALUE, JSONUtil.toJsonStr(sixTConfirmInfo));

                String taxUnitDeductionId = this.saveTaxUnitDeduction(ctx, taxUnitInfo, year);
                Object[] param = new Object[]{null, taxUnitDeductionId, BOSUuid.create("46E337F4").toString()};
                params.add(param);
                if(null!=result) {
                    //ɹдԱǷ6w
                    this._saveStaffCollection(ctx,taxUnitInfo,result);
                }else{
                    throw new BOSException("ӿڵ쳣");
                }
            }
            String sqlString = "insert into T_HR_STaskIncomeTaxRelation (FTaskId,FBizId,Fid) values (?, ?, ?)";
            DbUtil.executeBatch(ctx, sqlString, params);
            return arrayList;
        } else {
            throw new BOSException("6ֱӿ۳Ա鼯ӿڷȱʧ");
        }
    }

    protected String saveTaxUnitDeduction(Context ctx, TaxUnitInfo taxUnit, int year) throws BOSException {
        IObjectPK pk;
        try {
            String taxUnitId = taxUnit.getId().toString();
            String deleteSQL = "delete from T_HR_STaxUnitDeduction where fTaxUnitId = '" + taxUnitId + "' and fYear = " + year;
            DbUtil.execute(ctx, deleteSQL);
            deleteSQL = "delete from t_hr_sTaxDirectDeduction where fTaxUnitDeductionId in (select fid from T_HR_STaxUnitDeduction where fTaxUnitId = '" + taxUnitId + "' and fYear = " + year + ")";
            DbUtil.execute(ctx, deleteSQL);
            TaxUnitDeductionInfo info = new TaxUnitDeductionInfo();
            info.setTaxUnit(taxUnit);
            info.setYear(year);
            info.setIsCollection(true);
            pk = TaxUnitDeductionFactory.getLocalInstance(ctx).save(info);
        } catch (EASBizException var8) {
            LOG.error("_saveStaffCollection error: ", var8);
            throw new BOSException(var8.getMessage());
        }

        return pk.toString();
    }

    protected String getTaxUnitDeduction(Context ctx, TaxUnitInfo taxUnit, int year) throws BOSException {
        String oql = "select id where taxUnit.id = '" + taxUnit.getId().toString() + "' and year = " + year;
        TaxUnitDeductionCollection collection = TaxUnitDeductionFactory.getLocalInstance(ctx).getTaxUnitDeductionCollection(oql);
        if (null != collection && !collection.isEmpty()) {
            return collection.get(0).getId().toString();
        } else {
            throw new BOSException("ûҵ˰λ鼯Ϣ");
        }
    }


    protected synchronized void _saveStaffCollection(Context ctx, TaxUnitInfo taxUnit, String result) throws BOSException {
        JSONObject object = JSONUtil.parseObj(result);
        JSONObject head = object.getJSONObject("head");
        Map<String, Object> headMap = (Map)object.get("head");
        Map<String, Object> bodyMap = (Map)object.get("body");
        if ("00000000".equals(head.getStr("code"))) {
            System.out.println("_saveStaffCollection:start");
            List<Map<String, Object>> kczglbList = (bodyMap.containsKey("kczglb") ? (List<Map<String, Object>>) bodyMap.get("kczglb") : null);
            if (null != kczglbList && !kczglbList.isEmpty()) {
                String prefix = "person_collect_";
                String resource = taxUnit.getId().toString();
                boolean flag = CmpDistributedLockUtils.tryLock(ctx, prefix, resource);
                if (flag) {
                    try {
                        int year = taxUnit.getInt("year");
                        String taxUnitDeductionId = this.getTaxUnitDeduction(ctx, taxUnit, year);
                        Map<String, Integer> personMap = new HashMap();
                        String userId = HRFilterUtils.getCurrentUserId(ctx);
                        Iterator itgjrylb = kczglbList.iterator();

                        while(itgjrylb.hasNext()) {
                            Map<String, Object> stringObjectMap = (Map)itgjrylb.next();
                            personMap.put(stringObjectMap.get("zzhm").toString(), "".equals(stringObjectMap.get("kcbs")) ? 1 : 0);
                        }
                        String cardNumbers = CmpStrUtil.converMapToString(personMap);
                        String sql = "SELECT e.fid, r.fCardNumber FROM t_hr_sTaxPersonRecordEntry e, t_hr_sTaxPersonRecord r WHERE e.fTaxUnitID = '" + resource + "' " + " and e.fBillId = r.fid " + " and r.fCardNumber IN (" + cardNumbers + ")";
                        IRowSet rowSet = DbUtil.executeQuery(ctx, sql);
                        Timestamp createTime = new Timestamp(System.currentTimeMillis());
                        List<Object[]> paramList = new ArrayList();
                        HashMap personSet = new HashMap();

                        while(rowSet.next()) {
                            Object[] param = new Object[10];
                            String taxPersonRecordEntryId = rowSet.getString(1);
                            param[0] = taxPersonRecordEntryId;
                            Integer isDirect = (Integer)personMap.get(rowSet.getString(2));
                            param[1] = isDirect;
                            param[2] = taxUnitDeductionId;
                            param[3] = userId;
                            param[4] = createTime;
                            param[5] = userId;
                            param[6] = createTime;
                            param[7] = BOSUuid.create("F831C6DA").toString();
                            param[8] = "";
                            param[9] = 10;
                            personSet.put(taxPersonRecordEntryId, isDirect);
                            paramList.add(param);
                        }
                        System.out.println("_saveStaffCollection:"+JSONUtil.toJsonStr(paramList));
                        String batchSql = "INSERT INTO T_HR_STAXDIRECTDEDUCTION( FTaxPersonRecordEntryId, FISDECDUT, FTAXUNITDEDUCTIONID, FCREATORID, FCREATETIME,  FLASTUPDATEUSERID, FLASTUPDATETIME, FID, FTaskId, fSate)  VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                        DbUtil.executeBatch(ctx, batchSql, paramList);
                        sql = "UPDATE t_hr_sTaxPersonRecordEntry SET fIsDirect = ? WHERE fid = ?";
                        paramList = new ArrayList();
                        Iterator itPersonSet = personSet.entrySet().iterator();

                        while(itPersonSet.hasNext()) {
                            Map.Entry<String, Integer> entry = (Map.Entry)itPersonSet.next();
                            Object[] param = new Object[]{entry.getValue(), entry.getKey()};
                            paramList.add(param);
                        }
                        DbUtil.executeBatch(ctx, sql, paramList);
                        System.out.println("_saveStaffCollection:"+JSONUtil.toJsonStr(paramList));
                    } catch (Exception var33) {
                        LOG.error("_saveStaffCollection error: ", var33);
                    } finally {
                        CmpDistributedLockUtils.unlock(ctx, prefix, resource);
                    }
                }
            }
        }else{
            throw new BOSException(result);
        }
    }
    /**
     * ȷԱ
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void personCollectConfirmAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        String selectedData = request.getParameter("selectedData");
        ArrayList ids = new ArrayList();

        try {
            String oql;
            if (StringUtils.isEmpty(selectedData)) {
                super.prepareQueryList(request, response, modelMap);
                EntityViewInfo defaultEntityViewInfo = (EntityViewInfo)modelMap.get("DataGridEntityView");
                oql = "select id, sate where " + defaultEntityViewInfo.getFilter().toSql();
            } else {
                oql = "select id, sate where id in " + CmpStrUtil.buildInSql(selectedData);
            }
            StringBuilder msg = this.checkBeforeConfirm(ctx, ids, oql);
            if(msg.length()>0) {
                throw new BOSException(msg.toString());
            }else {
                int lastYear = CmpDateUtil.getYear(new Date());
                Map<String, Object> map = new HashMap();
                map.put("ids", ids);
                map.put("period", lastYear + "-01");
                TaxDirectDeductionExFacadeFactory.getLocalInstance(ctx).confirm(map);
            }
        } catch (Exception var10) {
            var10.printStackTrace();
            LOG.error("TaxDirectDeduction confirm failed, caused by: ", var10);
            throw new ShrWebBizException(var10.getMessage());
        }
    }

    /**
     * УѡǷѾȷ
     * @param ctx
     * @param ids
     * @param oql
     * @return
     * @throws BOSException
     */
    protected StringBuilder checkBeforeConfirm(Context ctx, List<String> ids, String oql) throws BOSException {
        StringBuilder msg = new StringBuilder();
        TaxDirectDeductionCollection collection = TaxDirectDeductionFactory.getLocalInstance(ctx).getTaxDirectDeductionCollection(oql);
        if (collection != null && !collection.isEmpty()) {
            for(int i = 0; i < collection.size(); ++i) {
                TaxDirectDeductionInfo info = collection.get(i);
                if (info.getSate() == TaxDeductionStateEnum.CONFIRMING || info.getSate() == TaxDeductionStateEnum.CONFIRMED) {
                    msg.append("벻ҪԡȷϡȷСԱٴηȷϡ");
                }

                ids.add(info.getId().toString());
            }

        } else {
            msg.append("ǰѡ޿ȷԱȵýӿ[ȡԱ]ɹٽȷ");
        }
        return msg;
    }



    /**
     * ȡ˰λ鼯¼
     * @param collection
     * @return
     */
    protected Map<String, List<TaxDirectDeductionInfo>> groupByTaxUnit(TaxDirectDeductionCollection collection) {
        Map<String, List<TaxDirectDeductionInfo>> map = new HashMap();

        for(int i = 0; i < collection.size(); ++i) {
            TaxDirectDeductionInfo info = collection.get(i);
            String taxUnitDeductionId = info.getTaxUnitDeduction().getId().toString();
            List<TaxDirectDeductionInfo> list = (List)map.get(taxUnitDeductionId);
            if (null == list) {
                list = new ArrayList();
            }

            ((List)list).add(info);
            map.put(taxUnitDeductionId, list);
        }

        return map;
    }
    protected Map<String, String> getAcceptIdMap(Context ctx, Map<String, List<TaxDirectDeductionInfo>> groups) throws BOSException {
        try {
            String sql = "select t3.fAccept_id acceptId, t1.fid fid from t_hr_sTaxUnitDeduction t1, T_HR_STaskIncomeTaxRelation t2, t_hr_sTaxCalTask t3 where t1.fid = t2.fBizId and t2.fTaskId = t3.fid and t1.fid in (" + CmpStrUtil.convertSetToSqlString(groups.keySet()) + ")";
            Map<String, String> acceptIdMap = new HashMap();
            IRowSet rs = DbUtil.executeQuery(ctx, sql);

            while(rs.next()) {
                String key = rs.getString("fid");
                String acceptId = rs.getString("acceptId");
                acceptIdMap.put(key, acceptId);
            }

            return acceptIdMap;
        } catch (Exception var8) {
            LOG.error("getAcceptIdMap error: ", var8);
            throw new BOSException(var8.getMessage());
        }
    }
}
